Update the README file
[ext/instance-debootstrap.git] / create.in
index 562fa7d..a1e82ff 100755 (executable)
--- a/create.in
+++ b/create.in
 
 set -e
 
-# Customize this if you need another mirror, or set to empty to get the
-# node's sources.list
-MIRROR="http://ftp.debian.org/debian"
-DPKG_ARCH="`dpkg --print-architecture`"
-CACHE_FILE="cache-${DPKG_ARCH}.tar"
+DEFAULT_FILE="@sysconfdir@/default/ganeti-instance-debootstrap"
+if [ -f "$DEFAULT_FILE" ]; then
+    . "$DEFAULT_FILE"
+fi
+
+# note: we don't set a default mirror since debian and ubuntu have
+# different defaults, and it's better to use the default
+
+# only if the user want to specify a mirror in the defaults file we
+# will use it, this declaration is to make sure the variable is set
+: ${MIRROR:=""}
+: ${SUITE:="lenny"}
+: ${ARCH:=""}
+: ${EXTRA_PKGS:=""}
+: ${GENERATE_CACHE:="yes"}
+: ${CLEAN_CACHE:="14"} # number of days to keep a cache file
+
+CACHE_DIR="@localstatedir@/cache/ganeti-instance-debootstrap"
+
+if [ "$GENERATE_CACHE" = "yes" -a ! -d "$CACHE_DIR" ]; then
+  mkdir -p "$CACHE_DIR"
+fi
+
+DPKG_ARCH=${ARCH:-`dpkg --print-architecture`}
+CACHE_FILE="$CACHE_DIR/cache-${SUITE}-${DPKG_ARCH}.tar"
 
 TEMP=`getopt -o i:b:s: -n '$0' -- "$@"`
 
@@ -32,22 +52,22 @@ if [ $? != 0 ] ; then echo "Terminating..." >&2 ; exit 1 ; fi
 # Note the quotes around `$TEMP': they are essential!
 eval set -- "$TEMP"
 
-while true; do 
-       case "$1" in
-               -i) instance=$2; shift 2;;
+while true; do
+  case "$1" in
+    -i) instance=$2; shift 2;;
 
-               -b) blockdev=$2; shift 2;;
+    -b) blockdev=$2; shift 2;;
 
-               -s) swapdev=$2; shift 2;;
+    -s) swapdev=$2; shift 2;;
 
-               --) shift; break;;
+    --) shift; break;;
 
-               *)  echo "Internal error!"; exit 1;;
-       esac
+    *)  echo "Internal error!"; exit 1;;
+  esac
 done
 if [ -z "$instance" -o -z "$blockdev" -o -z "$swapdev" ]; then
-       echo "Missing -i or -b or -s argument!"
-       exit 1
+  echo "Missing -i or -b or -s argument!"
+  exit 1
 fi
 
 mkswap $swapdev
@@ -65,37 +85,36 @@ mount $MOUNT_OPTIONS $blockdev $TMPDIR
 
 # remove the cache file if it's old (> 2 weeks) and writable by the owner (the
 # default due to the standard umask)
-if [ -f "$CACHE_FILE" ]; then
-       find "$CACHE_FILE" -perm -0200 -daystart -mtime +14 -print0 | \
-               xargs -r0 rm -f
+if [ "$CLEAN_CACHE" -a -d "$CACHE_DIR" ]; then
+  find "$CACHE_DIR" -name 'cache-*.tar' -type f \
+    -daystart -mtime "+${CLEAN_CACHE}" -print0 | \
+    xargs -r0 rm -f
 fi
 
 if [ -f "$CACHE_FILE" ]; then
-       tar xf "$CACHE_FILE" -C $TMPDIR
+  tar xf "$CACHE_FILE" -C $TMPDIR
 else
-       # On i386, we need the xen-specific library
-       if [ "$DPKG_ARCH" = "i386" ]; then
-               EXTRAPKG="linux-image-xen-686 libc6-xen"
-       elif [ "$DPKG_ARCH" = "amd64" ]; then
-               EXTRAPKG="linux-image-xen-amd64"
-       fi
-
-       debootstrap --include="$EXTRAPKG" etch $TMPDIR $MIRROR
-
-       # remove the downloaded debs, as they are no longer needed
-       find "$TMPDIR/var/cache/apt/archives" -type f -name '*.deb' -print0 | \
-               xargs -r0 rm -f
-
-       # remove the persistent-net rules, otherwise it will remember the node's
-       # interfaces as eth0, eth1, ...
-
-       rm -f "$TMPDIR/etc/udev/rules.d/z25_persistent-net.rules"
-
-       if [ ! -e no_cache ]; then
-               TMP_CACHE=`mktemp "${CACHE_FILE}.XXXXXX"`
-               tar cf "$TMP_CACHE" -C $TMPDIR .
-               mv -f "$TMP_CACHE" "$CACHE_FILE"
-       fi
+  # INCLUDE will be empty if EXTRA_PKGS is null/empty, otherwise we
+  # build the full parameter format from it
+  INCLUDE=${EXTRA_PKGS:+"--include=$EXTRA_PKGS"}
+  debootstrap \
+    --arch "$DPKG_ARCH" \
+    $INCLUDE \
+    "$SUITE" $TMPDIR $MIRROR
+
+  # remove the downloaded debs, as they are no longer needed
+  find "$TMPDIR/var/cache/apt/archives" -type f -name '*.deb' -print0 | \
+    xargs -r0 rm -f
+
+  # remove the persistent-net rules, otherwise it will remember the node's
+  # interfaces as eth0, eth1, ...
+  rm -f "$TMPDIR/etc/udev/rules.d/z25_persistent-net.rules"
+
+  if [ "$GENERATE_CACHE" = "yes" ]; then
+    TMP_CACHE=`mktemp "${CACHE_FILE}.XXXXXX"`
+    tar cf "$TMP_CACHE" -C $TMPDIR .
+    mv -f "$TMP_CACHE" "$CACHE_FILE"
+  fi
 fi
 
 cp -p /etc/hosts $TMPDIR/etc/hosts